#define far 
#define near
#define CONST               const
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#define Bool                int
#define STATUS_SUCCESS      0

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef FLOAT               *PFLOAT;
typedef BOOL near           *PBOOL;
typedef BOOL far            *LPBOOL;
typedef BYTE near           *PBYTE;
typedef BYTE far            *LPBYTE;
typedef int near            *PINT;
typedef int far             *LPINT;
typedef WORD near           *PWORD;
typedef WORD far            *LPWORD;
typedef long far            *LPLONG;
typedef DWORD near          *PDWORD;
typedef DWORD far           *LPDWORD;
typedef void far            *LPVOID;
typedef void far            *LPCVOID;

typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned int        *PUINT;

#define	MAX_PATH	260

/*
 *  File structures
 */

typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
/*    HANDLE  hEvent; */
} OVERLAPPED, *LPOVERLAPPED;

/*
 * NT data structure redefines
 */
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef char * PCHAR;
typedef short * PSHORT;
typedef long * PLONG;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned char * PUCHAR;
typedef unsigned short * PUSHORT;
typedef unsigned long * PULONG;
typedef char CCHAR;
typedef short CSHORT;
typedef ULONG CLONG;
typedef CCHAR * PCCHAR;
typedef CSHORT * PCSHORT;
typedef CLONG * PCLONG;
typedef void VOID;
typedef void * PVOID;
typedef struct _LARGE_INTEGER {
	ULONG LowPart;
	LONG HighPart;
} LARGE_INTEGER;
typedef LARGE_INTEGER * PLARGE_INTEGER;
typedef LARGE_INTEGER PHYSICAL_ADDRESS;
typedef LARGE_INTEGER * PPHYSICAL_ADDRESS;
typedef struct _ULARGE_INTEGER {
	ULONG LowPart;
	ULONG HighPart;
} ULARGE_INTEGER;
typedef ULARGE_INTEGER * PULARGE_INTEGER;

/*
 * Boolean
 */

typedef UCHAR BOOLEAN;
typedef BOOLEAN *PBOOLEAN;

typedef unsigned char	    WCHAR;
typedef WCHAR		    *PWCHAR, *PWSTR;
typedef WCHAR	    *LPCWSTR, *PCWSTR;

/*
 * Unicode strings are counted 16-bit character strings. If they are
 * NULL terminated, Length does not include trailing NULL.
 */

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;

typedef	int HANDLE;
typedef	HANDLE	*PHANDLE;

typedef long NTSTATUS;


/*
 * Define the base asynchronous I/O argument types
 */

typedef struct _IO_STATUS_BLOCK {
    NTSTATUS Status;
    ULONG Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;


struct nt2unixioctl {
        LPVOID ntstatus; /* address of NT status block */
        LPVOID lpvInBuffer; /* address of buffer for input data */
        DWORD cbInBuffer; /* size of input buffer */
        LPVOID lpvOutBuffer; /* address of output buffer */
        DWORD cbOutBuffer; /* size of output buffer */
        LPDWORD lpcbBytesReturned; /* address of actual bytes of output */
        LPOVERLAPPED lpoOverlapped; /* address of overlapped structure */
        };
