# imbapi.mak
# This makefile will build the imbapi library
#
#
# buildwin.cmd sets VCDIR, the directory containing VisualStudio 6.0 VC.
LIBC=/LIBPATH:%VCDIR%\lib 
INCL=%VCDIR%\include

# The source directory
SRC_D=.
INC=-I$(INCL) -I$(SRC_D) -I$(SRC_D)\inc
O_LIB=imbapi.lib

# Set your compiler options
CC=cl
CF_EX=/DWIN32 $(INC)
# CFLAGS= /MD /W3 /WX /Ox /O2 /Ob2 /Gs0 /GF /Gy /nologo $(CF_EX)
CFLAGS= /W3 /Ox /O2 /Ob2 /Gs0 /GF /Gy /nologo $(CF_EX)
LINK=link
LFLAGS=/nologo /subsystem:console /machine:IX86 /opt:ref $(LIBC)
MKDIR=-mkdir
MKLIB=lib
MLFLAGS= /nologo /subsystem:console /machine:I386 /opt:ref /dll
RM=del

LIB_OBJ = imbapi.obj 

HEADERS = 

all: banner $(O_LIB)

banner:
	@echo Building imbapi library

install:

clean:
	$(RM) *.obj
	$(RM) $(O_LIB)
	$(RM) *.dll

distclean:
	$(RM) *.obj
	$(RM) $(O_LIB)
	$(RM) *.lib
	$(RM) *.dll

imbapi.obj:    imbapi.c
    $(CC) /c $(CFLAGS) imbapi.c

$(O_LIB):    $(LIB_OBJ)
    $(MKLIB) /OUT:$(O_LIB) /nologo $(LIB_OBJ)

